% Set parameters for music
% "%--" before a comment of a parameter indicates that this parameter is important
%
% Author: Zhiyao Duan
% Created: 6/20/2012
% Last modified: 5/31/2013

% parameters for preprocessing input signal
frameLen = 2048;                            %-- 46ms for fs=44100
zpf = 4;                                    % zero padding factor
win = hamming(frameLen, 'periodic');        % window function
hop = 441;                                  %-- 10ms for fs=44100
RMS_th = sqrt(0.075);                       % frame whose RMS lower than this threshold will be considered silent

% parameters for peak extraction
peakTh = 50;                                % global amplitude threshold (dB)
peakTh_rel = 4;                             % local amplitude threshold (dB)
peakTh_freq = 20000;                        % frequency threshold (Hz)
movL = 400;                                 % moving average width (Hz)
localRange = 0;                             % the range for considering local maximum

% ----------- Streaming --------------------
% parameters for must-link and cannot-link constraints
MSL_pd = 0.3;                               % pitch difference threshold of must-link (midi number)
CNL_opth = 30;                              % cannot link overlap threshold (ms)

% parameters for calculating clustering features
FeatureType = 'UDC';                        % 'HarmStruct', 'UDC', 'MFCC'
maxHarm = 50;                               %-- upper bound of the harmonic number
Thresh_PeakF0Belong = 0.3;                  % (for harmonic structure, cepstrum and discrete cepstrum)
                                                % frequency deviation threshold to decide wheather a peak belongs to a F0 (semitone)
harmOvlpTh = 40;                            %-- (for MFCC feature only) frequency deviation threshold of two harmonics to be
                                                % judged being non-overlapped. Possible values: 40Hz (since 20Hz is
                                                % -6dB decrease for hamming window of length 46ms); 60Hz (since 30Hz
                                                % is -6dB decrease for hamming
                                                % window of length 32ms);
cepsOrder = 21;                             % (for cepstrum, discrete cepstrum and MFCC) order of the cepstrum feature
DistType = 'Euclidean';                     % 'Euclidean' or 'Mahalanobis' (experiments show 'Euclidean' is faster and not worse than 'Mahalanobis'

% parameters for note formation
bNoteForm = 0;                              % 0: not form notes, 1: form notes
mergeNoteGap = 100;                         %-- threshold for note formation (ms), two notelets with gap less than this threshold can be merged
minNoteLength = 100;                        %-- threshold for note length (ms), notelets shorter than this will be removed
