function plotSpecEnvFromDisCeps(ceps, fs, fftLen, color)
% function plotSpecEnv(ceps, fs, color)
% Plot spectral envelope from cepstra coefficients. There might be a
% scaling issue here.
% 
% Input
%   - ceps  : discrete cepstrum coefficients
%   - fs    : sampling rate of the audio file
%   - fftLen: length of fft size
%   - color : color scheme, 1 - blue, 2 - red, other - black
%
% Author: Zhiyao Duan
% Created: 7/19/2012
% Last modified: 7/19/2012

if nargin<4
    color = 0;
end
f = (0:10:16000)/fs;
envelope = ceps(1);
for n = 1:length(ceps)-1
    envelope = envelope + 2*ceps(n+1)*cos(2*pi*f*n);
end
envelope = envelope * 4/fftLen;
if color==1
    plot(f*fs, envelope, 'b-');
elseif color==2
    plot(f*fs, envelope, 'r-');
else
    plot(f*fs, envelope, 'k-');
end